package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;

import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class PassThroughClassLocatorImpl implements ClassLocator
{
	private final List<ETLTestClass> classes;
	private Iterator<ETLTestClass> it;

	public PassThroughClassLocatorImpl(List<ETLTestClass> classes)
	{
		this.classes = classes;

		// sort to guarantee ordering
		Collections.sort(classes);

		reset();
	}

	@Override
	public boolean hasNext()
	{
		return it.hasNext();
	}

	@Override
	public ETLTestClass next()
	{
		return it.next();
	}

	@Override
	public void remove()
	{
		throw new UnsupportedOperationException();
	}

	@Override
	public void reset()
	{
		it = classes.iterator();
	}
}
